Attribute VB_Name = "MP3Reader"
' -----------------------------------------------
' MP3-Header auslesen mit einer DLL Version 1.6
' entwickelt von Stefan Tngi seit 27.12.2001
' Update auf Version 1.6 am 20.04.2003
'             http://www.toengi.de
' -----------------------------------------------
'                     Freeware
' -----------------------------------------------
'
'Copyright (c) 2001-2003, Stefan Tngi
'THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
'"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
'LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
'CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
'EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
'PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
'PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
'LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
'NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
'SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'
' HINWEISE:
' Die Struktur muss den unten angegebenen Aufbau haben
' sonst funktioniert die DLL nicht oder Absturz des Programmes !
' Die Namen knnen selbstverstndlich anders gewhlt werden
'
' Es wird folgendermassen vorgegangen:
'
' 1. DLL wie unten angegeben deklarieren
'   z.B. Declare Sub Mp3FileInfo Lib "MP3READER.DLL" (ByVal FileName$, lpmpg As mpgstruct)
'
' 2.Struktur wie unten angegeben definieren und dimensionieren
'   z.B. Global mpg As mpgstruct
'
' 3. Aufruf der Routine mit Parameterbergabe Filename und Strukt
'  z.B.   Mp3FileInfo Fil$, mpg
'     wobei Fil$ der Dateiname der MP3-Datei ist und mpg die Variable der Struktur mpgstruct
'
' Das wars!
' In den einzelnen Feldern steht entweder -1 fr einen Fehler
' oder ein gltiger Wert mit Bedeutung wie unten angegeben
' -----------------------------------------------
' Bei Fragen oder Problemen knnt Ihr mailen an:
'               Stefan@Toengi.de
' -----------------------------------------------
' die aktuellste Version findet Ihr im Netz unter:
'                www.toengi.de
' -----------------------------------------------
' Ich wre fr eine Rckmeldung sehr dankbar!!
' da ich nicht so viele MP3s zum Testen habe, sagt mir bitte Bescheid
' wenn was falsch ist oder ein Fehler auftritt
'   Stefan Tngi 2001,2002,2003
' ////////////////////////////////////////////////////////////////////////////////////
'
' Die vorgegene Struktur-Reihenfolge und Feldgrssen NICHT verndern!! sonst Crash!
' Die Variablen-Namen knnen natrlich verndert werden
Type mpgstruct
    ValidHeader As Integer   ' 0=ungltiger Header, 1=gltiger Header
    MpegID As Integer        ' 0=reserviert, 1=MPEG 1.0, 2=MPEG 2.0, 3=MPEG 2.5
    Layer As Integer         ' 0=unbekannt, 1=Layer 1, 2=Layer 2, 3=Layer 3
    CRC As Integer           ' 0=nein, 1=ja
    Bitrate As Integer       ' 0=reserviert, >0=Bitrate in kbit/s
    Samplerate As Long       ' Samplerate in Hz
    Padding As Integer       ' 0=nein, 1=ja
    Private As Integer       ' 0=nein, 1=ja
    Stereomode As Integer    ' 0=Stereo, 1=Joint Stereo, 2=Zweikanal, 3=Mono
    ExtendedMode As Integer  ' Werte von 0-3
    Copyright As Integer     ' 0=nein, 1=ja
    Original As Integer      ' 0=nein, 1=ja
    Emphasis As Integer      ' 0=keine, 1=50/15ms, 2=unbekannt, 3=CCITT j.17
    Duration As Long         ' Gesamtspielzeit in Sekunden z.B. 210 Sekunden
    Minutes As Integer       ' Spielzeit in Minuten        z.B.   3 Minuten
    Seconds As Integer       ' Spielzeit in Sekunden       z.B.  30 Sekunden
    HeaderPos As Long        ' Anfangsposition des Headers
    Framelength As Long      ' Framelnge
    FrameCount As Long       ' Anzahl Frames
    FileSize As Long         ' Filelnge in Bytes
    VBR As Integer           ' 0=kein VBR, 1=VBR (variable Bitrate z.B.Xing)
    ID3V1Header As Integer   ' 0=kein Header, 1=ID3V1.0 Header, 2=ID3V1.1 Header
    ID3V2Header As Integer   ' 0=kein ID3V2 Header, 1=ID3V2 Header vorhanden
    ID3V2Pos As Long         ' Anfangsposition des ID3v2-Headers
    ID3V2Len As Long         ' Lnge des ID3v2-Headers
    ID3V2MajorVer As Integer ' Versionsnummer des ID3V2-Tags
    ID3V2MinorVer As Integer ' Revisions-Nummer des ID3V2-Tags
    Lyrics As Integer        ' 0=kein Lyrics3-Tag, 1=Lyrics3 Vers.1.0 vorhanden, 2=Lyrics3 Vers.2.0 vorhanden
    LyricsPos As Long        ' Anfangsposition des Lyrics3-Tag (zeigt auf "LYRICSBEGIN")
    '
    ' Nun kommen die ID3v1 Informationen mit Space aufgefllt!
    ' eventuell gelesene Null-Byte-Zeichen ( CHR$(0) ) wurden durch Space ersetzt!
    '
    Title As String * 30     ' Titel
    Artist As String * 30    ' Interpret
    Album As String * 30     ' Album
    Year As String * 4       ' Jahr
    Comment As String * 30   ' Kommentar
    Genre As String * 30     ' Musik-Genre als Text ( untersttzt Winamp-Genres)
    GenreID As Integer       ' Genre-Index, -1 = kein Genre, 0 - 148
    TrackNr As Integer       ' Track-Nr ( nur bei ID3V1.1 )
    '
    ' Nun folgen die ID3v2 Informationen mit Space aufgefllt!
    ' Untersttzt wird ID3 Version 2.0.x bis 2.4.x !!
    ' Das sind natrlich nicht alle, sondern nur die wichtigsten
    ' falls ihr der Meinung seid, es sollten noch welche dazukommen,
    ' dann mailt mir eure Vorschlge an: stefan@toengi.de
    ' WICHTIG: Bei mehrfachem Vorkommen des gleichen Tags
    ' wird immer nur der erste gefundene geliefert!
    ' die Feldgrssen sind auf maximal 255 Zeichen ausgelegt ( ausser Kommentar )
    ' sollte ein Frame grsser sein, so werden nur die ersten 255 Zeichen geliefert
    '
    ID3V2Track As String * 255     ' Track Nr
    ID3V2Year As String * 255      ' Jahr
    ID3V2Title As String * 255     ' Titel
    ID3V2Artist As String * 255    ' Artist
    ID3V2Album As String * 255     ' Album
    ID3V2Genre As String * 255     ' Genre
    ID3V2Composer As String * 255  ' Komponist
    ID3V2OriginalArtist As String * 255 ' Original Artist
    ID3V2Copyright As String * 255 ' Copyright
    ID3V2Encoder As String * 255   ' Encoder
    ID3V2Url As String * 255       ' benutzerdefinierte URL
    ID3V2Comment As String * 2000  ' Kommentar
End Type

'
' Die Deklarationen der einzelnen DLL-Aufrufe (Pfade evtl anpassen!)
'
' Haupt-Aufruf ( fllen der Struktur mpgstruct )
Declare Sub Mp3FileInfo Lib "D:\MP3ReaderDLL\debug\MP3READER.DLL" (ByVal FileName$, lpmpg As mpgstruct)
'
' Schreiben des ID3V1-Tags ( Titel, Interpret, Album etc )
Declare Sub WriteID3V1 Lib "MP3READER.DLL" (ByVal FileName$, lpmpg As mpgstruct)
'
' Entfernen des ID3V1-Tags
Declare Sub EraseID3V1 Lib "MP3READER.DLL" (ByVal FileName$)
'
' Entfernen der gesamten ID3V2-Tags
Declare Sub EraseID3V2 Lib "MP3READER.DLL" (ByVal FileName$)
'
' Entfernen des Lyrics-Tags
Declare Sub EraseLyrics Lib "MP3READER.DLL" (ByVal FileName$)
